;-_-_-_-_-_-_-_-_-_-_-_-_STEP Sürücü_-_-_-_-_-_-_-_-_-_-_-_-_;
;Step motor 100ms aralıklı darbelerle sürülüyor
;yüksek tork modu kullanılacak
;1100
;0110
;0011
;1001
;dönme yönüne gelirsek:
;ortak pin sonuncu olmak üzere yani;
;sarı=1,siyah=2,turuncu=3,kahverengi=4. pin
;pinler sıralarına göre ters bağlanınca yani
;1-7,2-6,3-5,4-4: bağlanması durumunda
;sağa kaydırma işlemi saat yönünde dönmeyi
;sola kaydırma işlemi saat yönünün tersine dönmeyi sağlıyor
;--------------------------------------------------------------
;programın bu ikinci sürümü SMController1 programının bütün
;komutlarını yerine getirecek. bunlar:
;iki hareket modu, adım modu, sürekli dönme
;hız ayarı
;yön belirleme (adım modunda adım yönü)
;-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_;

LIST P=16F628A
INCLUDE "P16F628A.INC"

    __CONFIG _WDT_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_ON & _BODEN_OFF & _LVP_OFF & _DATA_CP_OFF & _CP_OFF


VARIABLE bellek_basi=h'20'


		ORG		0X00

;-_-_-_-_-_-_-_-_-_-_--_-_-_Tanımlamalar_-_-_-_-_-_--_-_-_-_-_-_-_-_-_-_-;

;Bellek tanımlamaları
CBLOCK bellek_basi
	S_BEK_1,S_BEK_2			;Zamanlama programında kullanılan sayaçlar
	GF_PR	;Geçici reg kullanarak kaydırma yapan makrolar ppRLF&ppRRF için gerekli reg
	
	;döndürme işlemi için gerekli regler
	DONME_REG	;b0=0 için sağa b0=1 için sola dön
			;b1=0 için dur b1=1 için devamlı dön
	DONME_HIZ	;Hız verisinin saklandığı reg
	KAY_REG		;kaydırma işlemi sırasında kullanılan bit, kullanılmayan ilk 4 bit 0lanacağı için direk portb kaydırılmıyor
	
	;iletişim için ve testler için gerekli REGler
	VTEST_REG
	
ENDC

;Makro tanımlamaları

;Bu makrolar RLF ve RRF komutlarının yaptığı işin aynısını yapıyor,
;yalnız kayıp düşen bit diğer taraftan ekleniyor
pRLF	macro	bunu
	BCF	STATUS,C
	RLF	bunu,f
	BTFSC	STATUS,C
	BSF	bunu,0
	endm

pRRF	macro	bunu
	BCF	STATUS,C
	RRF	bunu,f
	BTFSC	STATUS,C
	BSF	bunu,7
	endm
	
;Bu makrolar geçici bir reg (GF_PR) kullanıyorlar, böylece step motor sürerken sorun çıkmıyor
ppRLF	macro	bunu
	MOVF	bunu,w
	MOVWF	GF_PR
	pRLF	GF_PR
	MOVF	GF_PR,w
	MOVWF	bunu
	endm
	
ppRRF	macro	bunu
	MOVF	bunu,w
	MOVWF	GF_PR
	pRRF	GF_PR
	MOVF	GF_PR,w
	MOVWF	bunu
	endm
	
;bit kopyalayan makro
copyb	macro	bundan,x1,buna,x2
	BTFSC	bundan,x1
	BSF	buna,x2
	BCF	buna,x2
	endm

;-_-_-_-_-_-_-_-_-_-_-_-_-_-_Hazırlıkk-_-_-_-_-_-_-_--_-_-_-_-_-_-_-_-_-_-_;

;------------------------Port Ayarları-----------------------------------;

		
		MOVLW	h'07'		;PORTA'nın uçları I/O
		MOVWF	CMCON
		
 		BANKSEL	TRISA
 		
 		MOVLW	h'FF'
 		MOVWF	TRISA		;PORTA giriş
 		
		MOVLW	b'00000010'	;RB0=çıkış, RB1/RX=giriş,RB2/TX=çıkış
		MOVWF	TRISB
		
;------------------------İletişim Ayarları-------------------------------;
		
		MOVLW	d'25'		;4mhz'de 9600 Baud Rate için
		MOVWF	SPBRG
		MOVLW	b'00100100'	;bit4-SYNC=0 (asenkron), bit2-BRGH=1 (yüksek hız modu), bit5-TXEN=1 gönderme aktif
		MOVWF	TXSTA
		
		BANKSEL	PORTB		;BANK0'a geç
		
		MOVLW	b'10010000'	;SPEN=1 (seri port aktif) , CREN=1 (sürekli verialma aktif)
		MOVWF	RCSTA

;-_-_-_-_-_-_-_-_-_-_-_-_-_-_Program-_-_-_-_-_-_-_-_--_-_-_-_-_-_-_-_-_-_;

BASLA		CLRF	PORTB
		MOVLW	b'00110011'	;başlangıç durumu
		MOVWF	KAY_REG
		MOVLW	b'00000000'
		MOVWF	DONME_REG

;------------------ANA PROGRAM DONGUSU-----------------------------------;

		
DONGU1		BTFSS	DONME_REG,1	;DUR mu? : dönme modunda mı, durma modunda mı
		
		GOTO	VERI_AL_DUR
		GOTO	DON_VERI_AL
		
VERI_AL_DUR	CALL	VERI_AL		;DUR  halindeymiş, veri almaya git ve işle ve anadöngüye dön..
		MOVF	DONME_HIZ,w	;iletişimi test için veri geri gönderiliyor, 
		CALL	VERI_GONDER	;durma modunda hız ayarlanırsa PIC veriyi aynen programa gönderecek
		GOTO	DONGU1
				
					;Sürekli dönme modunda imiş, bir adım dön		
		
DON_VERI_AL	BTFSC	DONME_REG,0	;0 sağa,1 sola
		GOTO	SOLA_ADIM_1
				
SAGA_ADIM_1	pRRF	KAY_REG
		
		GOTO	DONGU1_D1
		
SOLA_ADIM_1	pRLF	KAY_REG
		
		
portb_maske	EQU	b'11110000'

DONGU1_D1	MOVF	KAY_REG,w
		XORWF	PORTB,w
		ANDLW	portb_maske
		XORWF	PORTB,f
		
		CALL	BEKLET2
		
		CALL	VERI_AL		;adım modunda buraya gereksiz yere gelmiş olacak ama mühim değil 4us falan
		CLRF	PORTB		;adım modunda, dururken akım çekmeyi önlüyor
			
		
		GOTO	DONGU1
		
;----------------VERI AL ve İŞLE PROGRAMI--------------------------------------;

VERI_AL		BTFSS	PIR1,RCIF	;RCIF 1'mi?
		RETURN			;Hayır, veri gelmemiş, bitir
		MOVF	RCREG,W		;Veri gelmiş, RCREG'i W'ya yükle
		
		;veri alındı şimdi kontrol edilecek ve gerekli bilgiler, gerekli REGlere yüklenecek
		MOVWF	VTEST_REG	;Gelen veri buraya yüklendi, test yapılacağı zaman buradan alınack
		
;--TEST1: Bu bir hız verisi mi? yani veri>0x03 mü?
		SUBLW	0x03		;W'dan 0x03ü çıkar negatifse hız verisidir
		BTFSC	STATUS,C	;0 ise negatiftir yani hız verisidir
		GOTO	TEST_2
		
		;veriden 0x03 çıkar ve hız REGine kaydet
		MOVLW	0x03
		SUBWF	VTEST_REG,w
		MOVWF	DONME_HIZ
		
		RETURN			;Veri al programında çık
		
		
;--TEST2: hız verisi değil peki "sola dön" komutu mu? 		
TEST_2		MOVLW	0x03
		SUBWF	VTEST_REG,w
		BTFSS	STATUS,Z	;eğer 1 ise sonuç 0'dır yani sola dön komutudur, yoksa test3'e geç
		GOTO	TEST_3
		
		;demekki sola dön komutu, sola dönme modunu kaydet ve döndür
		BSF	DONME_REG,0
		GOTO	SOLA_ADIM_1
		
		;burada RETURN olmasını beklerdim amma yukardaki komuta geçtiği için gerek yok
		
;--TEST3: "sola dön" değil, peki "sağa dön" komutu mu?
TEST_3		MOVLW	0x02
		SUBWF	VTEST_REG,w
		BTFSS	STATUS,Z	;eğer 1 ise sonuç 0'dır yani sağa dön komutudur, yoksa test4'e geç
		GOTO	TEST_4
		
		;demekki sağa dön komutu, sağa dönme modunu kaydet ve döndür
		BCF	DONME_REG,0
		GOTO	SAGA_ADIM_1
		
		;burada da RETURN olmasını beklerdim amma yukardaki komuta geçtiği için gerek yok
		
;--TEST4: "sağa dön" değil, peki "dönmeye başla" komutu mu?
TEST_4		MOVLW	0x01
		SUBWF	VTEST_REG,w
		BTFSS	STATUS,Z
		GOTO	TEST_5
		
		;dönmeye başla komutu
		BSF	DONME_REG,1
		RETURN

;--TEST5: yukarıdakilerden hiçbir olmadığına göre dur komutudur ama yine de test etmekte fayda var	
TEST_5		MOVF	VTEST_REG,f
		BTFSS	STATUS,Z
		RETURN			;hata söz konusudur, hiç birşey yapma
		
		;durma komutu
		BCF	DONME_REG,1
		RETURN
		
		
;--------------Alınan veriyi gönderen alt program----------------------------------;
VERI_GONDER	BSF	PORTB,2		;RB2/TX ucu 'start' (1) durumunda
		CALL	GONDER
		RETURN
		
;---------------RCREG'den Veri Okuma Alt Programı !!ESKİ---------------------------;

VERI_AL_ISLE	BTFSS	PIR1,RCIF	;RCIF 1'mi?
		GOTO	VERI_AL_ISLE	;Hayır, tekrar test et
		MOVF	RCREG,W		;Veri gelmiş, RCREG'i W'ya yükle
		RETURN
		
;-----------------TXREG'den STA'ya veri yükleme Alt programı-----------------------;

GONDER		MOVWF	TXREG		;W->TXREG
		BANKSEL	TXSTA		;BANK1'e geç
VERIST		BTFSS	TXSTA,TRMT	;STA'ya veri gönderme bitti mi?
		GOTO	VERIST
		BANKSEL	PORTB		;BANK0'a geç
		RETURN

;-------------------------BEKLETME ALT PROGRAMI 2----------------------------------;

;Bu program yukarıdakinden farklı olarak DONME_HIZI REG'ine bağlı bir süre bekliyor

;Beklet'de harcanan tur sayısı=6+M*(7+3*N)
;M=198,N=DONME_HIZI: 

BEKLET2		MOVLW	d'198'			;M		
		MOVWF	S_BEK_1		
	
D_BEK_11	MOVF	DONME_HIZ,w		;N
		MOVWF	S_BEK_2

D_BEK_12	DECFSZ	S_BEK_2,f	
		GOTO	D_BEK_12

		DECFSZ	S_BEK_1,f
		GOTO	D_BEK_11

		RETURN

		
		END	