#include "SMController.h"
#include "ui_SMController.h"

SMController::SMController(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::SMController)
{
    ui->setupUi(this);

	//Initialize serial port listener and configure
	if(listener.connectToPort()){

		ui->statusBar->showMessage(tr("Connected to serial port"));

		if(listener.configurePort()) {

			ui->statusBar->showMessage(tr("Port configured"));

			//Set signal+slot connection and start listening
			QObject::connect(&listener,SIGNAL(dataReaded(QString)),this,SLOT(incomingData(QString)));
			listener.startReading();

			//Also set conncection to stop listening when application quited
			QObject::connect(QCoreApplication::instance(),SIGNAL(aboutToQuit()),&listener,SLOT(stopReading()));

		}else{

			ui->statusBar->showMessage(tr("Cannot configure port"));

		}

	}else{

		ui->statusBar->showMessage(tr("Cannot connect to serial port"));

	}


}


SMController::~SMController() {
    delete ui;
}

void SMController::incomingData(QString p) {

	ui->statusBar->showMessage(tr("Data received: ")+p);

}

void SMController::on_checkConMove_toggled(bool checked) {

	if(checked) {

		listener.writeText(QByteArray::fromHex(QString("01").toLatin1()));

	}else {

		listener.writeText(QByteArray::fromHex(QString("00").toLatin1()));

	}

}

void SMController::on_buttonRight_clicked() {

	listener.writeText(QByteArray::fromHex(QString("02").toLatin1()));

}

void SMController::on_buttonLeft_clicked() {

	listener.writeText(QByteArray::fromHex(QString("03").toLatin1()));

}

void SMController::on_buttonSet_clicked() {

	listener.writeText(QByteArray::fromHex(QString::number((101-ui->spinBox->value())+3+16,16).toLatin1()));
	//dikkat +3,bunun hız komutu olduğunu belirtmek için eklendi, +16 ise darbe sayısının 100'den yüksek olmaması için

}
