#include "SerialListener.h"

SerialListener::SerialListener(QObject *parent) :
    QObject(parent)
{
}

bool SerialListener::connectToPort() {

	readingStopped = true;

	fd = open("/dev/ttyS0",O_RDWR | O_NOCTTY | O_NDELAY );

	if(fd!=-1){
		return true;	//success
	}else{
		return false;	//failure
	}

}

bool SerialListener::configurePort() {

	struct termios options;

	tcgetattr(fd,&options);
/*
	qDebug()<<options.c_cc;
	qDebug()<<options.c_cflag;
	qDebug()<<options.c_iflag;
	qDebug()<<options.c_ispeed;
	qDebug()<<options.c_lflag;
	qDebug()<<options.c_line;
	qDebug()<<options.c_oflag;
	qDebug()<<options.c_ospeed;
*/
	cfsetispeed(&options,B9600);
	cfsetospeed(&options,B9600);


	options.c_cflag &= ~PARENB;			//No parity
	options.c_cflag &= ~CSTOPB;			//1 stop bit
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;				//8 bits
	options.c_cflag &= ~CRTSCTS;		//donanım akış kontrolü devre dışı

	//options.c_lflag &= ~ICANON;			//non-canonical=raw input mode!
	options.c_lflag &= 0;					//GTKTerm'den kopya..!

	//options.c_oflag &= ~OPOST;			//raw output
	//options.c_oflag &= ~ONLCR;

	options.c_cflag |= (CLOCAL | CREAD);

	fcntl(fd, F_SETFL, FNDELAY);

	if (tcsetattr(fd,TCSANOW,&options)!=0) {

		return false;	//failure

	}else{

		return true;	//success

	}

}

void SerialListener::readLoop() {

	QByteArray buffer(1,*("0"));

	while(!readingStopped){

		int wordsRead = read(fd,buffer.data(),1);

		if (wordsRead>0) {

			emit dataReaded(buffer.toHex());

		}
	}
}

void SerialListener::startReading() {

	readingStopped = false;

	QtConcurrent::run(this,&SerialListener::readLoop);

}

void SerialListener::stopReading() {

	readingStopped = true;

}

bool SerialListener::writeText(QByteArray p) {

	int n = write(fd,p,p.size());

	if(n<0){

		return false;	//failure

	}else{

		return true;	//success

	}

}

