#ifndef SERIALLISTENER_H
#define SERIALLISTENER_H

#include <QObject>

#include <QtGui>

//---------------------------For serial connections
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
//---------------------------For serial connections

class SerialListener : public QObject
{
    Q_OBJECT
public:
    explicit SerialListener(QObject *parent = 0);

	bool connectToPort();
	bool configurePort();

private:

	int fd;
	bool readingStopped;
	void readLoop();

signals:

	void dataReaded(QString);

public slots:

	void startReading();
	void stopReading();

	bool writeText(QByteArray);

};

#endif // SERIALLISTENER_H
